<template>
  <div>
    <p class="window-title">{{ title }}</p>
    <p class="step-title">por {{ creator }}, hace un dia</p>
    <v-container >
      <v-layout justify-center row>
        <v-flex xs11>
        <v-card>
          <v-card-title class="blue">
            <div class="white--text">
              <h3 class="text-xs-left">Descripción</h3>
              <h5 class="text-xs-left">{{ description }}</h5>
            </div>
          </v-card-title>
          <v-data-table
          :headers="headers"
          :items="votes"
          :hide-actions="true">
          <template slot="headers" slot-scope="props">
            <tr>
              <th>
              </th>
              <th v-if="!voted">
                <v-text-field v-model="current_vote.name"></v-text-field>
              </th>
              <th
                v-for="header in props.headers"
                :key="header.text"
                class="active">
                {{ header.text }}
              </th>
            </tr>
          </template>
          <template slot="items" slot-scope="props">
            <td>
              {{ props.item.option }}
            </td>
            <td v-if="!voted">
              <v-checkbox v-model="current_vote.options[props.index].value"
                color="blue"
                true-value="1"
                false-value="0"
                hide-details
              ></v-checkbox>
            </td>
            <td class="text-center lighten-4"
            v-for="value in props.item.values"
            :key="value.name"
            :class="{ 'red': value.value === 0, 'blue': value.value === 1 }">
              <v-icon v-if="value.value === 1" v-text="'done'"
              :color="value.value === 0 ? 'red' : 'blue'">
              </v-icon>
            </td>
          </template>
        </v-data-table>
        </v-card>
      </v-flex>
      <v-flex>
        <v-layout column>
        <v-btn v-on:click="addVote"
                color="pink"
                dark
                small
                fab
              >
                <v-icon>save</v-icon>
              </v-btn>
          </v-layout>
        </v-flex>
      </v-layout>
    </v-container>
  </div>
</template>

<script>
const axios = require('axios');

export default {
  data: () => {
    return {
      voted: false,
      creator: 'Pablo',
      title: 'Proyectos Coruña Hacks',
      description : 'Votación para decidir cuál es el proyecto más molón en esta edición de Coruña Hacks',
      headers: [
        { text: 'Juan' },
        { text: 'Antonio' },
        { text: 'Jack' },
        { text: 'Daniel' }
      ],
      votes: [{
        option: 'FYD',
        values: [
          { name: 'Juan', value: 0 },
          { name: 'Antonio', value: 1 },
          { name: 'Jack', value: 0 },
          { name: 'Daniel', value: 0 }
        ]
      },
      {
        option: 'QAS',
        values: [
          { name: 'Juan', value: 1 },
          { name: 'Antonio', value: 0 },
          { name: 'Jack', value: 0 },
          { name: 'Daniel', value: 1 }
        ]
      },
      {
        option: 'Matrix contributions',
        values: [
          { name: 'Juan', value: 1 },
          { name: 'Antonio', value: 0 },
          { name: 'Jack', value: 1 },
          { name: 'Daniel', value: 0 }
        ]
      },
      {
        option: 'Aloha',
        values: [
          { name: 'Juan', value: 0 },
          { name: 'Antonio', value: 1 },
          { name: 'Jack', value: 0 },
          { name: 'Daniel', value: 0 }
        ]
      }],
      current_vote: {
        name: '',
        options: [
          {value: 0}, {value: 0}, {value: 0}, {value: 0}
        ]
      }
    }
  },
  props: {

  },
  created: function () {
    const id = this.$route.params.id;
    var axiosObj = {
      method: "GET",
      url: 'http://localhost:8090/questions/'+id,
      headers:{
        'Content-Type': 'application/ld+json'        
      }
    };
    var self = this;
    axios(axiosObj).then(function(questionRes) {
      console.log('ok', questionRes);
      self.questionId = id;
      self.title = questionRes.data.name;
      self.votes = questionRes.data.answers.map((it) => ({
        id: it['@id'],
        option: it.name,
        values: [],
      }));
      self.current_vote.options = self.votes.map((it) => ({
        id: it.id,
        value: 0,
      }));
      self.headers = [];
      var axiosObj = {
        method: "GET",
        url: 'http://localhost:8090/votes?question='+id,
        headers:{
          'Content-Type': 'application/ld+json'        
        }
      };
      axios(axiosObj).then(function(votesRes) {
        const list = [];
        votesRes.data['hydra:member'].forEach((it) => {
          const member = {
            name: it.nameVoter,
            answerId: it.answer,
          }
          self.votes.filter((it) => it.id === member.answerId)
            .forEach((v) => v.values.push({ name: member.name, value: 1 }));
          const names = {};
          votesRes.data['hydra:member'].forEach((it) => { names[it.nameVoter] = true });
          self.headers = Object.keys(names).map((it) => ({ text: it }));
        });
        console.log('votes')
      }).catch(function(errors) {
        console.log('error');
      });

    }).catch(function(errors) {
      console.log('error');
    });
  },
  methods: {
    addVote: function () {
      console.log('addVote', this.current_vote.name);
      this.current_vote.options.forEach((option, i) => console.log('option ' + i, option.value));
      this.headers.unshift({text: this.current_vote.name});
      for( var i in this.current_vote.options) {
        var vote = {
          name: this.current_vote.name,
          value: parseInt(this.current_vote.options[i].value)
        };
        console.log('Adding votes', vote);
        this.votes[i].values.unshift(vote);
        this.voted = true;
      }
      axios.defaults.headers.post['Content-Type'] = 'application/ld+json';
      axios.defaults.baseURL = 'http://localhost:8090/votes';

      const promises = this.current_vote.options.map((it) => {
        var axiosObj = {
          method: "POST",
          data: JSON.stringify({
            nameVoter: this.current_vote.name,
            answer: it.id,
            question: self.questionId,
          }),
          headers:{
            'Content-Type': 'application/ld+json'        
          }
        };
        return axios(axiosObj);
      });
      Promise.all(promises, (res) => {
        console.log('ok', res);
      }).catch((err) => {
        console.log(err);
      });
    }
  }
}
</script>

<style>
  .not-known {
    position: relative;
  }
  .not-known::before {
    content: '( ';
    position: absolute;
    top: -5px;
    left: -4px;
  }
  .not-known::after {
    content: ' )';
    position: absolute;
    top: -5px;
    right: -6px;

  }
  .v-card {
    margin: auto;
  }
</style>
